#!/usr/bin/env python

#***********************************************************************
# RPM Wizard
# Copyrigt 2001 Magnus Bjorklof <bjorklof@nic.fi>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.
# If not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#***********************************************************************

import sys
import commands
import os
import string
import math
import re
import popen2
import det

from test import *
from conf import *

from qt import *

filename=''
error_message=''

ar=sys.argv[0]
qfilei=QFileInfo(ar)
APPDIR=str(qfilei.dirPath(1))




class RpmWiz(QWizard):
    def __init__(self,parent = None,name = None,modal = 0,fl = 0):
        QWizard.__init__(self,parent,name,modal,fl)


        self.image0 = QPixmap(APPDIR + '/imagerpm.png')

	icon=QPixmap(APPDIR + '/rpmwiz.png')



        self.setIcon(icon)
        self.setCaption(NAME)

        self.resize(570,413)
	self.setMinimumSize(570,413)
        self.setMaximumSize(700,420)

	self.currentp=1
       

	#---------- Page 1-------------
	self.page = QWidget(self,'page')

        Layout11 = QWidget(self.page,'Layout11')
        Layout11.setGeometry(QRect(170,5,370,310))
        vbox = QVBoxLayout(Layout11)
        vbox.setSpacing(6)
        vbox.setMargin(0)

        self.TextLabel1 = QLabel(Layout11,'TextLabel1')
        self.TextLabel1.setText('<b><font size=4><br>Welcome to</font><br><font size=5>the '+NAME+'!</font>')
	TextLabel1_font = QFont(self.TextLabel1.font())
	TextLabel1_font.setBold(1)
        TextLabel1_font.setPointSize(14)
        self.TextLabel1.setFont(TextLabel1_font)
        vbox.addWidget(self.TextLabel1)

	self.TextLabel1x = QLabel(Layout11,'TextLabel1')
        self.TextLabel1x.setText("""<br><br>This wizard will guide you through the
        process of installing an RPM package.<br><br><br>Please specify an RPM file to install
        and click Next when you are ready.""")

        vbox.addWidget(self.TextLabel1x)

	vbox_2 = QVBoxLayout()
        vbox_2.setSpacing(6)
        vbox_2.setMargin(0)

	hbox = QHBoxLayout()
        hbox.setSpacing(6)
        hbox.setMargin(0)

        self.LineEdit1 = QLineEdit(Layout11,'LineEdit1')
        self.LineEdit1.setText(QDir.currentDirPath())
        hbox.addWidget(self.LineEdit1)

        self.PushButton1 = QPushButton(Layout11,'PushButton1')
        self.PushButton1.setText(self.tr('Browse...'))
        hbox.addWidget(self.PushButton1)
        vbox_2.addLayout(hbox)

        spacer_2 = QSpacerItem(20,20,QSizePolicy.Minimum,QSizePolicy.Expanding)
        vbox_2.addItem(spacer_2)

	vbox.addLayout(vbox_2)

	self.image(self.page)

        self.addPage(self.page,self.tr('Select file'))

        #------- Page 1 ends---------


	#------- Page 2 ---------
        self.page2 = QWidget(self,'page2')

        self.LayoutWidget = QWidget(self.page2,'Layout19')
        self.LayoutWidget.setGeometry(QRect(165,1,395,320))
        Layout19 = QVBoxLayout(self.LayoutWidget)
        Layout19.setSpacing(6)
        Layout19.setMargin(5)

        self.TextLabel1 = QLabel(self.LayoutWidget,'TextLabel1')
        self.TextLabel1.setText(self.tr('Welcome!'))
        TextLabel1_font = QFont(self.TextLabel1.font())
        TextLabel1_font.setBold(1)
        TextLabel1_font.setPointSize(14)
        
        self.TextLabel1.setFont(TextLabel1_font)
        Layout19.addWidget(self.TextLabel1)
        
        self.TextLabel1_3 = QLabel(self.LayoutWidget,'TextLabel1_3')
        self.TextLabel1_3.setText(self.tr('You are about to install:'))
        Layout19.addWidget(self.TextLabel1_3)

        self.TextLabel1_2 = QLabel(self.LayoutWidget,'TextLabel1_2')
        self.TextLabel1_2.setText('') # program name
        TextLabel1_2_font = QFont(self.TextLabel1_2.font())
        TextLabel1_2_font.setBold(1)
        self.TextLabel1_2.setFont(TextLabel1_2_font)
        Layout19.addWidget(self.TextLabel1_2)
        spacer = QSpacerItem(20,20,QSizePolicy.Minimum,QSizePolicy.Fixed)
        Layout19.addItem(spacer)

        self.TextLabel2_2 = QLabel(self.LayoutWidget,'TextLabel2_2')
        self.TextLabel2_2.setText(self.tr('Package description:'))
        Layout19.addWidget(self.TextLabel2_2)

        self.TextBrowser = QMultiLineEdit(self.LayoutWidget,'TextView')
        self.TextBrowser.setWordWrap(QMultiLineEdit.WidgetWidth)
        self.TextBrowser.setFrameStyle(QFrame.StyledPanel | QFrame.Sunken)
        
        self.TextBrowser.setReadOnly(1)
        self.TextBrowser.setText('')
        Layout19.addWidget(self.TextBrowser)
	
        Layout4 = QHBoxLayout()
        Layout4.setSpacing(6)
        Layout4.setMargin(0)
        spacer = QSpacerItem(20,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
        Layout4.addItem(spacer)

        self.PushButtonV = QPushButton(self.LayoutWidget,'PushButton1')
        self.PushButtonV.setText(self.tr('Details...'))
        Layout4.addWidget(self.PushButtonV)
        Layout19.addItem(Layout4)
	
        self.TextLabel2 = QLabel(self.LayoutWidget,'TextLabel2')
        self.TextLabel2.setText(self.tr('Press Next to start copying the files or Cancel to abort.'))
        Layout19.addWidget(self.TextLabel2)

        self.image(self.page2)

        self.addPage(self.page2,'')
        #------- Page 2 ends---------

	#------- Page 3 -----------------------------------------------
        self.page3 = QWidget(self,'page3')
	self.image(self.page3)

	#------- Page 3a --------- self.page3a
	self.page3a = QLabel(self.page3,'TextLabel4')
        self.page3a.setGeometry(QRect(160,0,390,320))
        self.page3a.setText(self.tr('Preparing installation. Please wait...'))
        self.page3a.setAlignment(QLabel.AlignCenter)
	#------- Page 3a ends---------


        #------- Page 3b --------- self.page3b
	self.page3b = QWidget(self.page3,'Layout20')
        self.page3b.setGeometry(QRect(165,120,385,55))
        Layout20 = QVBoxLayout(self.page3b)
        Layout20.setSpacing(6)
        Layout20.setMargin(0)

        self.TextLabel2_3 = QLabel(self.page3b,'TextLabel2_3')
        self.TextLabel2_3.setText(self.tr('Installing: ...'))
        Layout20.addWidget(self.TextLabel2_3)

        self.ProgressBar33 = QProgressBar(self.page3b,'ProgressBar33')
        Layout20.addWidget(self.ProgressBar33)
        self.page3b.hide()
	#------- Page 3b ends---------

        #------- Page 3c --------- self.page3c
	self.page3c = QWidget(self.page3,'Layout23')
        self.page3c.setGeometry(QRect(220,140,280,110))
        Layout23 = QVBoxLayout(self.page3c)
        Layout23.setSpacing(6)
        Layout23.setMargin(0)

        self.TextLabel3 = QLabel(self.page3c,'TextLabel3')
        self.TextLabel3.setText(self.tr('Congratulations! Installation successful.'))
        TextLabel3_font = QFont(self.TextLabel3.font())
        TextLabel3_font.setBold(1)
        self.TextLabel3.setFont(TextLabel3_font)
        Layout23.addWidget(self.TextLabel3)

        self.TextLabel4_2 = QLabel(self.page3c,'TextLabel4_2')
        self.TextLabel4_2.setText(self.tr('Enjoy your new software!'))
        Layout23.addWidget(self.TextLabel4_2)
        spacer_3 = QSpacerItem(20,20,QSizePolicy.Minimum,QSizePolicy.Expanding)
        Layout23.addItem(spacer_3)

	self.CheckBox1 = QCheckBox(self.page3c,'CheckBox1')
	self.CheckBox1.setGeometry(QRect(200,260,153,19))
	self.CheckBox1.setText(self.tr('Install another package'))
	Layout23.addWidget(self.CheckBox1)

	self.page3c.hide()

        #------- Page 3c ends---------


	self.addPage(self.page3,self.tr(''))
	#------- Page 3 ends------------------------------

	self.connect(self.PushButton1,SIGNAL('clicked()'),self.getFileName)
        self.connect(self.LineEdit1,SIGNAL('textChanged(const QString&)'),self.enableNext)
	self.connect(self.PushButtonV,SIGNAL('clicked()'),self.details)

        self.setNextEnabled(self.page, 0)
        self.PushButton1.setDefault(1)
        self.helpButton().setText('About...')

	self.getInfo()
        self.setMsg()

	self.resizeCount=0
    def details(self):
    	"""This function is called when the user clicks the 'Details...' button."""

        files_=commands.getoutput("rpm -qpl " + self.fileName(1))

        files=re.split('\012', files_)

	name=commands.getoutput("rpm -qp --queryformat %{NAME} " + self.fileName(1))
        summary=commands.getoutput("rpm -qp --queryformat %{SUMMARY} " + self.fileName(1))
	version=commands.getoutput("rpm -qp --queryformat %{VERSION} " + self.fileName(1))
        group=commands.getoutput("rpm -qp --queryformat %{GROUP} " + self.fileName(1))
        size=commands.getoutput("rpm -qp --queryformat %{SIZE} " + self.fileName(1))
        depends_=commands.getoutput("rpm -qp --requires " + self.fileName(1))
	distribution=commands.getoutput("rpm -qp --queryformat %{DISTRIBUTION} " + self.fileName(1))
        vendor=commands.getoutput("rpm -qp --queryformat %{VENDOR} " + self.fileName(1))
        packager=commands.getoutput("rpm -qp --queryformat %{PACKAGER} " + self.fileName(1))

	depp=re.split('\012', depends_)
	depends=''

	for d in depp:

 		if depends=='':
			depends=string.strip(d)
		else:
			depends=depends+', '+string.strip(d)


	provides_=commands.getoutput("rpm -qp --provides  " + self.fileName(1))

	prov=re.split('\012', provides_)
	provides=''
        for p in prov:
        	if provides=='':
			provides=string.strip(p)
		else:
                	provides=provides+', '+string.strip(p)

        desc="""<table>
        <tr><td><b>Name:</b></td><td>"""+name+"""</td></tr>
        <tr><td><b>Summary:</b></td><td>"""+summary+"""</td></tr>
        <tr><td><b>Version:</b></td><td>"""+version+"""</td></tr>
        <tr><td><b>Group:</b></td><td>"""+group+"""</td></tr>
        <tr><td><b>Size:</b></td><td>"""+size+"""</td></tr>
        <tr><td><b>Depends:</b></td><td>"""+depends+"""</td></tr>
        <tr><td><b>Provides:</b></td><td>"""+provides+"""</td></tr>
        <tr><td><b>Distribution:</b></td><td>"""+distribution+"""</td></tr>
        <tr><td><b>Vendor:</b></td><td>"""+vendor+"""</td></tr>
        <tr><td><b>Packager:</b></td><td>"""+packager+"""</td></tr>
	</table>
        """


	self.dt=det.DetailsDialog(self)
 	self.dt.setValues(desc,files)
        self.dt.setCaption('Details - '+NAME)

        self.dt.show()

    def image(self, page):
    	"""Sets the image of the wizard."""
    	self.PixmapLabel1 = QLabel(page,'PixmapLabel1')
        self.PixmapLabel1.setGeometry(QRect(5,5,154,320))
        self.PixmapLabel1.setPixmap(self.image0)
        self.PixmapLabel1.setScaledContents(0)
        self.PixmapLabel1.setFrameShape(QLabel.StyledPanel)
        self.PixmapLabel1.setFrameShadow(QLabel.Sunken)
        self.PixmapLabel1.setIndent(0)
	
    def enableNext(self):
    	"""Enables the 'Next' button on first page. Only done if the filename is set."""
    	if self.fileName()!='':
        	self.setNextEnabled(self.page, 1)
        	self.nextButton().setDefault(1)
	else:
        	pass

    def fileName(self, c=0):
    	"""Fuction that represents the filename."""
        if c==0:
    		return str(self.LineEdit1.text())
	elif c==1:
        	s=string.strip(str(self.LineEdit1.text()))
		ss=string.replace(s, ' ', '\ ')
		return ss
	else:
        	pass

    def getFileName(self):
    	"""Opens a file dialog to get the name of the rpm file to install."""
	fn = QFileDialog()

        fname = fn.getOpenFileName(None , 'RPM Files (*.rpm);;All Files (*)' , self  , 'Open file', 'Open...')


        if str(fname)!='':
        	self.LineEdit1.setText(fname)
	else:
        	pass


    def getInfo(self):
        """Get some information from the RPM file and manipulate it to look better."""

        getinfodescr="rpm -qp --queryformat %{DESCRIPTION} " + self.fileName(1)
	self.desc3 = commands.getoutput(getinfodescr)
	desc2=re.split('\012\012', self.desc3)
	str=''

        for x in desc2:
		s=string.replace(x, '\012', ' ')
                str=str + s + '\012\012'

        str=string.strip(str)
        self.desc=str

        self.TextBrowser.setText(self.desc)

    def setMsg(self):
        """Sets the appropriate name and error message. If there is no error message it is set to ''."""

        getinfoname="rpm -qp --queryformat %{NAME} " + self.fileName(1)
        getinfovers="rpm -qp --queryformat %{VERSION} " + self.fileName(1)

        global error_message
        if error_message==None:
                error_message=''
        else:
                pass

        if error_message!='': # hmm, this could maybe be removed...
                self.name=self.fileName()
        else:
                self.name2 = commands.getoutput(getinfoname)
                self.vers = commands.getoutput(getinfovers)
                self.name = self.name2 + ' ' + self.vers

    def resizeEvent(self, ev):
    	"""Handles some resizing (this code sucks :)."""

        self.resizeCount=self.resizeCount+1
        if self.resizeCount>1:
                #cwidth is the change in width of the window
                cwidth=(self.width() - ev.oldSize().width())
		self.LayoutWidget.resize((self.LayoutWidget.width() + cwidth), self.LayoutWidget.height())

    def installRpm(self):
        """Handles the install process."""

        qApp.processEvents()
        self.testRpm()
        qApp.processEvents()

        if self.cont == 1:
                arg=""
	elif self.cont == 2:
                arg="--force --nodeps "
        elif self.cont == 0:
                return

        self.changePage3('b')

        self.ProgressBar33.setProgress(0)
        self.takeSomeTime(5000)

        self.cmd = "rpm -U --percent " + arg + self.fileName(1)
        self.pipe=popen2.Popen4(self.cmd)

	while self.pipe.poll() == -1:

                list=string.split(self.pipe.fromchild.readline())
		if list==[]:
			list=['%%', '100']
   		else:
                	pass
                if list[0]=='%%': 
                    try:
                        flyt=string.replace(list[1], ",",".")
                    except IndexError:
                        print flyt
		    try:
                        flyttal=float(flyt)
                    except ValueError:
                        print flyt
                    heltal = math.floor(flyttal)

                    self.ProgressBar33.setProgress(heltal)
                    qApp.processEvents()
                else:
                    print list

        self.changePage3('c')

        self.setFinishEnabled(self.page3, 1)
	self.finishButton().setDefault(1)
        self.helpButton().setEnabled(1)

    def help(self):
    	"""Display help dialog."""
        self.about=QMessageBox.about(self, 'About...',"<b>"+ NAME+ ' '+APPVERSION+"""</b>
<br><br>Copyright (c) 2001 """+ u"""Magnus Bjrklf &#60;bjorklof@nic.fi&#62;<br><br>
Website: """+HOMEPAGE+"""<br><br>
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.""")


    def next(self):
        """This is what happens when the user pushes the Next button."""

	if self.currentp==1:

                self.setPage2(firstPage=0)

	elif self.currentp==2:
        	self.currentp==3

		self.TextLabel2_3.setText(self.tr('Installing: '+self.name+'...'))
		self.changePage3('a')
                self.showPage(self.page3)
        	self.cancelButton().setEnabled(0)
        	self.helpButton().setEnabled(0)
		self.finishButton().setEnabled(0)
        	self.takeSomeTime(2000)
        	self.installRpm()
	else:
        	pass

    def back(self):
    	"""This function is called when the user clicks the 'Back' button."""
	self.showPage(self.page)
	self.currentp=1
	self.setCaption(NAME)

    def changePage3(self, showPage):
    	"""The third page consists of 3 different pages (or sets of widgets). This function changes between them."""
	if showPage=='a':
        	self.page3a.show()
        	self.page3b.hide()
        	self.page3c.hide()

        elif showPage=='b':
        	self.page3a.hide()
        	self.page3b.show()
        	self.page3c.hide()

 	elif showPage=='c':
        	self.page3a.hide()
        	self.page3b.hide()
        	self.page3c.show()
	else:
        	pass

    def restart(self):
    	"""Restart the wizard."""
    	self.CheckBox1.setChecked(0)
        self.currentp=1

	self.setCaption(NAME)

	self.qfii=QFileInfo(self.LineEdit1.text())
	self.LineEdit1.setText(self.qfii.dirPath(1))

	self.changePage3('a')
	self.PushButton1.setDefault(1)
        self.cancelButton().setEnabled(1)
	self.setNextEnabled(self.page, 0)

	self.showPage(self.page)

    def accept(self):
 	"""This is run when user clicks 'Finish'. If the user has chosen to install more packages
	the wizard will restart."""
	if self.CheckBox1.isChecked()==1:
        	self.restart()
	else:
 		sys.exit(0)

    def takeSomeTime(self, time=1000):
        """This is just an ugly hack, needs work
        Needed to process some events so that the UI will update"""
        x=0
        
        while x<time:
                x=x+1
                qApp.processEvents()



    def testRpm(self):
        """Tests the RPM."""

        testStatus = commands.getoutput('rpm -U --test ' + self.fileName(1))

        if testStatus=='':
                self.cont = 1
        else:
                print testStatus
                text="This error message appeared when trying to install " + self.name + ":<br><br><b>" + testStatus + """</b>
<br><br>Press Continue to install despite the problem or press Restart to install another package.
Pressing Exit will exit the whole wizard.
<br><br>What do you want to do?"""
                mb = QMessageBox("Warning", text, QMessageBox.Warning, QMessageBox.Yes | QMessageBox.Default, QMessageBox.No , QMessageBox.Cancel)
		mb.setButtonText( QMessageBox.Yes, "Continue" )
                mb.setButtonText( QMessageBox.No, "Restart" )
                mb.setButtonText( QMessageBox.Cancel, "Exit" )
                mb.show()
                if mb.result() == QMessageBox.Yes:
                        self.cont = 2
                        self.takeSomeTime()

                elif mb.result() == QMessageBox.No:
                	self.cont=0
			self.restart()
                else:
			sys.exit(0)



    def startAtPage2(self, file):
    	"""Handles some things that has to be done when the wizard is started at the second page."""
	qfi=QFileInfo(file)
	fileAbs=qfi.absFilePath()
        self.LineEdit1.setText(fileAbs)

        t=self.setPage2()
        if t=='':
        	self.currentp=2
        else:
        	self.currentp=1

    def setPage2(self, firstPage=1):
    	"""Sets the info on the second page."""
    	error_message=testFile(self.fileName(), self.fileName(1))

	if error_message=='':
		self.currentp=2
                
                self.getInfo()
  		self.setMsg()
    		self.TextLabel1_2.setText(self.name)

                if firstPage==0:
                	self.TextLabel1.hide() #hiding welcome text
                        
                else:
                	pass
		self.setCaption(self.name + ' - ' + NAME)
               	self.showPage(self.page2)
                self.backButton().setEnabled(1)

	else:
		self.mb2=QMessageBox.critical(self, NAME , '<b>Error:</b><br>'+error_message, QMessageBox.Ok | QMessageBox.Default)

      	return error_message

if __name__ == '__main__':

    argg=1
    try:
       	sys.argv[1]
    except IndexError: # there are no arguments
	argg=0

    if argg==1:
	if sys.argv[1][0]=='-':
		filename = cltest()
	else:
		filename=sys.argv[1]
    else:
    	pass


    isRoot=userTest()

    a = QApplication(sys.argv)


    if isRoot==0:
        print "You have to be root to run this app."
	qmb=QMessageBox(NAME, 'Sorry, you have to be root to run this app.',QMessageBox.Information,QMessageBox.Ok|QMessageBox.Default, 0, 0)
	qmb.show()
	sys.exit(0)
    else:
        pass

    w = RpmWiz()
    a.setMainWidget(w)

    if filename!='':
    	w.startAtPage2(filename)
    else:
    	pass

    w.show()
    a.exec_loop()
