#***********************************************************************
# RPM Wizard
# Copyrigt 2001 Magnus Bjorklof <bjorklof@nic.fi>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.
# If not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#***********************************************************************

import commands
import sys
import getopt
import os

from conf import *
from qt import *

def help_message():

    print NAME+" "+APPVERSION+"""

Usage: rpmwiz <rpm-file>  or rpmwiz <options>

Options:
  -h     --help              display this help message and exit
  -v     --version           display version and exit"""
    sys.exit(0)


def cltest():
        """checking if there are any arguments, if not print help message and exit"""

        filename=''


        try:
                options, xarguments = getopt.getopt(sys.argv[1:], 'hv', ['help', 'version'])

        except getopt.GetoptError:
                print "Error: unknown option\n"
                help_message()

        for a in options[:]:
                if a[0] == '-h' or a[0] == '--help':
                        help_message()

        for a in options[:]:
                if a[0] == '--version' or a[0] == '-v':
                        print NAME + ' ' + APPVERSION + u'\nCopyright (c) 2001 Magnus Bjorklof '+EMAIL
                        sys.exit(0)


        return filename



def testFile(filename, filename1):
        """Tests if the file exists and can be read.
        Also tests if the file is a valid RPM file. Only the first error messsage
        that appears is displayed."""

        error_message=''

        qdir=QDir(filename)
        if qdir.exists()==1:
        	print "Error: No file specified"
		error_message="No file specified"
                return error_message
        else:
        	pass

        if os.access(filename, os.F_OK)==1:
                pass
        else:
                print "Error: No such file"
		error_message="No such file: "+ filename
                return error_message

        if os.access(filename, os.R_OK)==1:
                pass
        else:
                print "Error: File can't be read"
                error_message="File can't be read."
                return error_message

	#BUG:This fails when file path has white space
	
	testCmd = "rpm -qp --queryformat %{NAME} " + filename1
	q, q2=commands.getstatusoutput(testCmd)
        if q!=0:
            	print "Error: Not an RPM file"
            	error_message="The requested file is not an RPM file."
            	return error_message
	
        return error_message


def userTest():
        """Tests if the user has root privileges. If not it tries to find kdesu."""
        user=commands.getoutput('whoami')
        if user=='root':
                isRoot=1
        else:
		KDIR=os.getenv('KDEDIR')
		if KDIR!=None and KDIR!='':
			pass
		else:
			KDIR='/usr/'
		
		try:
			os.execv(KDIR+'/bin/kdesu', [sys.argv[0], '-c' ,'rpmwiz']+sys.argv[1:])
		except OSError:
			try:
				os.execv('/opt/kde2/bin/kdesu', [sys.argv[0], '-c' ,'rpmwiz']+sys.argv[1:])
			except OSError:
				pass
		isRoot=0

        return isRoot